package cn.com.infosec.asn1.cmp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERBitString;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;
import java.util.Enumeration;

public class PKIMessage extends ASN1Encodable {
   private PKIHeader header;
   private PKIBody body;
   private DERBitString protection;
   private ASN1Sequence extraCerts;

   private PKIMessage(ASN1Sequence seq) {
      Enumeration seq1;
      this.header = PKIHeader.getInstance((seq1 = seq.getObjects()).nextElement());
      this.body = PKIBody.getInstance(seq1.nextElement());

      while(seq1.hasMoreElements()) {
         ASN1TaggedObject var2;
         if ((var2 = (ASN1TaggedObject)seq1.nextElement()).getTagNo() == 0) {
            this.protection = DERBitString.getInstance(var2, true);
         } else {
            this.extraCerts = ASN1Sequence.getInstance(var2, true);
         }
      }

   }

   public static PKIMessage getInstance(Object o) {
      if (o instanceof PKIMessage) {
         return (PKIMessage)o;
      } else if (o instanceof ASN1Sequence) {
         return new PKIMessage((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   private void addOptional(ASN1EncodableVector v, int tagNo, ASN1Encodable obj) {
      if (obj != null) {
         DERTaggedObject var4;
         var4 = new DERTaggedObject.<init>(true, tagNo, obj);
         v.add(var4);
      }

   }

   public PKIHeader getHeader() {
      return this.header;
   }

   public PKIBody getBody() {
      return this.body;
   }

   public DERObject toASN1Object() {
      PKIMessage var10000 = this;
      PKIMessage var10001 = this;
      PKIMessage var10002 = this;
      ASN1EncodableVector var1;
      ASN1EncodableVector var10004 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.header);
      var10004.add(this.body);
      DERBitString var2 = this.protection;
      var10002.addOptional(var1, 0, var2);
      ASN1Sequence var3 = var10001.extraCerts;
      var10000.addOptional(var1, 1, var3);
      return new DERSequence(var1);
   }
}
